const express = require('express');
const bodyParser = require('body-parser');
const logger = require('morgan');

const mongoose = require('mongoose');

const app = express();

app.use(logger('dev'));
app.use(bodyParser.json({limit: '5mb'}));

// Mongoose
const connectionUrl =
    'mongodb://localhost:27017/imdb';
mongoose.connect(connectionUrl, {
   "useNewUrlParser": true,
   "socketTimeoutMS": 0,
   "keepAlive": true,
   "reconnectTries": 10
});

const directorSchema= new mongoose.Schema({
    "_id": Number,
    "name" : {
        type: String,
        required: true
    },
    "imdb": String
});
const genreSchema= new mongoose.Schema({
    "_id": Number,
    "name" : {
        type: String,
        required: true
    }
});
const movieSchema = new mongoose.Schema({
   "_id": Number,
   "title": {
       type: String,
       required: true,
       minLength: 3
   },
    "year": {
       type: Number,
        required: true,
        min: 1910
    },
    directors : [directorSchema],
    genres: [genreSchema]
});

let Movie = mongoose.model('movies1', movieSchema);

Movie.distinct('genres',(err,genres)=>{
    console.log(genres);
})